PROGRAM FactorsAndFactorials;

#include "str.h"

CONST probname = 'NZ93_';
      file_id = 'PROBLEM';
      prob_id = 'E';
      max = 100;

VAR   debugcounter: integer;
      N: integer;
      prime: array[1..max] of Boolean;

FUNCTION  ReadData: Boolean;     forward;
PROCEDURE SolveProblem;          forward;

PROCEDURE Error(s:string);
begin
  writeln; writeln(s); readln; HALT;
end;

PROCEDURE SetupPrimes;
var   i,j: integer;

begin
for i := 1 to max do prime[i] := true;
i := 1;
while i <= sqrt(max) do begin
  repeat Inc(i) until prime[i];
  j := i * i;
  while j <= max do begin
    prime[j] := false; j := j + i end;
  end;  {while i <= sqrt(max)}
end;  {Setup Primes}

PROCEDURE MainProg;
begin  {Main}

SetupPrimes;
while ReadData do
  SolveProblem;
end; {of main procedure}

function ReadData: Boolean;
begin
readln(N);
ReadData := n <> 0;
end;

FUNCTION f(N, p: integer): integer;
begin
if N < p
  then f := 0
  else f := N div p + f(N div p, p);
end;

PROCEDURE SolveProblem;
var i, j: integer;

begin
write(N:3, '! ='); j := 0;
for i := 2 to N do
  if prime[i]
    then begin
      if (j mod 15 = 0) and (j > 0)
        then begin writeln; write('      ') end;
      write(f(N,i):3); Inc(j) end;
writeln
end;

begin mainprog end.

